function base64_encode(decStr)
{
  var base64_characters =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  
  var bits, dual, i = 0, encOut = '';

  //decStr = escape(decStr); // line add for chinese char
  
  while(decStr.length >= i + 3){
    bits =
    (decStr.charCodeAt(i++) & 0xff) <<16 |
    (decStr.charCodeAt(i++) & 0xff) <<8  |
     decStr.charCodeAt(i++) & 0xff;
    encOut +=
     base64_characters.charAt((bits & 0x00fc0000) >>18) +
     base64_characters.charAt((bits & 0x0003f000) >>12) +
     base64_characters.charAt((bits & 0x00000fc0) >> 6) +
     base64_characters.charAt((bits & 0x0000003f));
  }
    
  if(decStr.length - i > 0 && decStr.length - i < 3)
  {
    dual = Boolean(decStr.length -i -1);
    bits =
     ((decStr.charCodeAt(i++) & 0xff) <<16) |
     (dual ? (decStr.charCodeAt(i) & 0xff) <<8 : 0);
    encOut +=
      base64_characters.charAt((bits & 0x00fc0000) >>18) +
      base64_characters.charAt((bits & 0x0003f000) >>12) +
      (dual ? base64_characters.charAt((bits & 0x00000fc0) >>6) : '=') +
      '=';
  }
  
  return encOut
}

function base64_decode(encStr)
{
  var base64_characters =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

  var bits = 0;
  var decOut = "";
  var i;

  for(i = 0; i< encStr.length; i += 4)
  {
    bits =
     (base64_characters.indexOf(encStr.charAt(i))     & 0xff) << 18 |
     (base64_characters.indexOf(encStr.charAt(i + 1)) & 0xff) << 12 | 
     (base64_characters.indexOf(encStr.charAt(i + 2)) & 0xff) <<  6 |
      base64_characters.indexOf(encStr.charAt(i + 3)) & 0xff;
    decOut += String.fromCharCode(
     (bits & 0xff0000) >>16, (bits & 0xff00) >>8, bits & 0xff);
  }
  
  if(encStr.charCodeAt(i - 2) == 61)
    undecOut=decOut.substring(0, decOut.length - 2);
  else
  if(encStr.charCodeAt(i - 1) == 61)
    undecOut = decOut.substring(0, decOut.length - 1);
  else
    undecOut = decOut;
  
  // undecOut = unescape(undecOut); // line add for chinese char
  return undecOut;
}

///////////////////////////////////////////////////////////

function url_encode(str)
{
  var url_encoded = "";

  for (var i = 0; i < str.length; i++) {
    if (str.charAt(i) == " ")
    {
      url_encoded += "%20";
    }
    else
    {
      url_encoded += str.charAt(i);
    }
  }

  return url_encoded;
}

///////////////////////////////////////////////////////////

function ReadHeader(socket) {
  var response_header = [];

  do {
    var line = "";

    var lh = 0;
    var ch = 0;
    var ba = null;
    var done = false;
    
    do {   
      ba = socket.read(1);
   
      if (ba != null) {
        ch = CreateStringFromByteArray(ba);
        
        if (ch != '\r' && ch != '\n') {
          line += ch;
        } else {
          if (ch == '\n') {
            if (line.length > 0) {
              response_header.push ( line );
            } else {
              done = true;
            }

            line = "";
          }
        }
      
        lh = ch;
      }
    } while ( ba != null && !done );
    
  } while ( line != null && line.length > 0);  

  return response_header;
}

///////////////////////////////////////////////////////////

function ReadDataToRawFile(socket, rawfile, content_length)
{
  var content_read = 0;
  var ba = socket.read(content_length - content_read);
  
  while (content_read < content_length && !IsKeyPressed(KEY_ESCAPE)) {
    if (1) {
      GetSystemFont().drawText(16, 16, "Reading data... " + Math.round((content_read / content_length) * 100) + "%");
      FlipScreen();
    }

    if (ba != null) {
      if (rawfile != null) {
        rawfile.write(ba);
      }
        
      content_read += ba.length;
    }
      
    if (content_read < content_length) {
      ba = socket.read(content_length - content_read);
    }
  }
  
  return content_read;
}

///////////////////////////////////////////////////////////
  
function ShowRemoteFile(url)
{
  var address = "";
  var port = 80;
  var rest = "/";
  var proto = "";

  // to configure proxy settings change these lines
  var proxy_username = "username";
  var proxy_password = "password";
  var proxy_address = "";
  var proxy_port = 80;

  var proxy_authorization = base64_encode(proxy_username + ":" + proxy_password);
  
  var error_func = function(str) {
    Abort(str);
  }

  if (url.indexOf("http://") != 0) {
    error_func("Invalid protocol or no protocol specified...\n");
    return null;     
  }
  else {
    proto = "http";
  }
  
  if ( url.indexOf("/", url.indexOf("://") + "://".length) != -1) {
    address = url.substring(url.indexOf("://") + "://".length, url.indexOf("/", url.indexOf("://") + "://".length));
    rest = url.substring(url.indexOf("/", url.indexOf("://") + "://".length));
  } else {
    address = url.substring(url.indexOf("://") + "://".length);  
  }
  
  GetSystemFont().drawTextBox(16, 16, GetScreenWidth() - 32, GetScreenHeight() - 32, 0, "Opening " + address + ", port " + port + "\n");
  FlipScreen();

  var use_proxy = (proxy_address != null && proxy_address.length > 0);
  var use_proxy_authorization = (proxy_username != null && proxy_username.length > 0) || (proxy_password != null && proxy_password.length > 0); 

  var socket = OpenAddress((use_proxy ? proxy_address : address), (use_proxy ? proxy_port : port));
  if (socket == null) {
    error_func("Could not connect to " + address + ", port " + port + "\n"
             + (use_proxy ? ("Using proxy: " + proxy_address + ", port " + port + "\n") : (""))
             + "(Check that you're connected to the internet and that sphere is"
             + " allowed to access the internet by running config...)\n");
    return null;
  }

  while ( !socket.isConnected() && !IsKeyPressed(KEY_ESCAPE) ) {
    GetSystemFont().drawTextBox(16, 16, GetScreenWidth() - 32, GetScreenHeight() - 32, 0,
      "Connecting to " + address + ", port " + port + "\n"
    + (use_proxy ? ("Using proxy: " + proxy_address + ", port " + proxy_port + "\n") : (""))
    + "\n"
      );

    FlipScreen();
  }
  
  if ( IsKeyPressed(KEY_ESCAPE) ) {
    return null;
  }
  
  if ( !socket.isConnected() ) {
    return null;
  }
  
  var request_header = "GET " + (use_proxy ? (proto + "://" + address + rest) : rest) + " HTTP/1.1\r\nHost: " + address + "\r\n";
  
  if (use_proxy && use_proxy_authorization) {
    request_header += "Proxy-Authorization: Basic " + proxy_authorization + "\r\n";
  }

  request_header += "\r\n";
  
  socket.write ( CreateByteArrayFromString(request_header) );

  while ( socket.getPendingReadSize() == 0 ) {
    GetSystemFont().drawText(16, 16, "Waiting for reply...");
    FlipScreen(); 
  }
  
  var response_header = ReadHeader(socket);

  if ( response_header.length == 0 ) {
    GetSystemFont().drawText(16, 16, "No response...");
    FlipScreen(); 
  } else {
    GetSystemFont().drawText(16, 16, "Got response...");
    FlipScreen();   
  }

  var version = "";
  var response_code = 0;
  var response_msg = "";
  
  var content_length = 0;
  var transfer_encoding = "";
  var content_type = "";
  
  // parse the response_header
  for (var i = 0; i < response_header.length; i++) {
    if (i == 0) {
      //HTTP/1.1 404 Not Found
      var tokens = response_header[i].split(" ");
      if (tokens.length >= 3) {
        version = tokens[0];
        response_code = tokens[1];

        for (var j = 2; j < tokens.length; j++) {
          response_msg += tokens[j];
          if (j + 1 < tokens.length) {
            response_msg += " ";
          }
        }
      }
    } else {
      if (response_header[i].indexOf("Content-Length: ") == 0) {
        content_length = response_header[i].substring("Content-Length: ".length);
      }
      else
      if (response_header[i].indexOf("Content-Type: ") == 0) {
        content_type = response_header[i].substring("Content-Type: ".length);
      }
      else
      if (response_header[i].indexOf("Transfer-Encoding: ") == 0) {
        transfer_encoding = response_header[i].substring("Transfer-Encoding: ".length);
      }
    }
  }

  // validate the response_header  
  if (version.indexOf("HTTP") != 0) {
    error_func("Unknown version type: " + version + "\n");
    return null;
  }
  
  if (response_code == 0) {
    error_func("Unknown response_code: " + response_code + "\n");
    return null;
  }
  
  if (transfer_encoding != "") {
    error_func("Unknown Transfer-Encoding: " + transfer_encoding + "\n");
    return null;
  } 
 
  if (content_type == "text/plain" || content_type == "text/html"
   || content_type.indexOf("text/html") == 0) { // show text files on the screen  

    if (1) {
      GetSystemFont().drawText(16, 16, "Reading data...");
      FlipScreen();
    }

    var ba = socket.read(content_length);
    if (ba != null) {
      var data = CreateStringFromByteArray(ba);
      var request_header_height = GetSystemFont().getStringHeight(request_header, GetScreenWidth() - 32);
      
      if (url.indexOf("http://translate.google.com/translate_t?") == 0) {
        var string_start_text = "<textarea name=q rows=5 cols=45 wrap=PHYSICAL>";
        var string_end_text   = "</textarea>";
        var string_start_pos = data.indexOf(string_start_text);
        var string_end_pos = 0;
        var string = "";
      
        if (string_start_pos != -1) {
          string_end_pos = data.indexOf(string_end_text, string_start_pos + string_start_text.length);
          if (string_end_pos != -1) {
            string = data.substring(string_start_pos + string_start_text.length, string_end_pos);
          }
        }
        
        data = string;
      }
      
      while ( !IsKeyPressed(KEY_ESCAPE) ) {
        GetSystemFont().drawTextBox(16, 16, GetScreenWidth() - 32, request_header_height, 0, request_header);
        GetSystemFont().drawTextBox(16, Math.max(16, request_header_height), GetScreenWidth() - 32, GetScreenHeight() - 32 - request_header_height, 0, data);
        FlipScreen();
      }
    }
    
  }
  else
  if (content_type == "image/png") { // show images on the screen

    var rawfile = rawfile = OpenRawFile("tmp.png", true);
    var content_read = ReadDataToRawFile(socket, rawfile, content_length);   

    if (rawfile) {
      rawfile.close();
      rawfile = null;
    }

    if ( IsKeyPressed(KEY_ESCAPE) ) {
      return null;
    }
    
    var image = LoadImage("~/other/tmp.png");

    while ( !IsKeyPressed(KEY_ESCAPE) ) {
      image.blit(16, 16);
      FlipScreen();
    }
  }
  
  return null;
}

///////////////////////////////////////////////////////////
  
function game(){
  ShowRemoteFile("http://translate.google.com/translate_t?langpair=en|de&text=" + url_encode("hello world") + "");
  while (IsKeyPressed(KEY_ESCAPE)) { }
  //ShowRemoteFile("http://sphere.sourceforge.net/flik/misc/mp3vsogg.txt");
  //while (IsKeyPressed(KEY_ESCAPE)) { }
  //ShowRemoteFile("http://sphere.sourceforge.net/flik/images/avatar.png");
}
